.386

;.MODEL flat,stdcall

OPTION CASEMAP:NONE

Include masm32rt.inc
Include debug.inc


IncludeLib user32.lib
IncludeLib kernel32.lib
IncludeLib masm32.lib
IncludeLib debug.lib

.DATA

;AppName			DB "DLL Skeleton",0


.code
ALIGN 4

FindAndReplace PROTO :LPSTR,:LPSTR,:LPSTR

DllEntry Proc hInstance:HINSTANCE, reason:DWORD, reserved1:DWORD
	MOV  EAX,TRUE
	RET
DllEntry EndP

;TestHello Proc lpText:LPSTR
;	Invoke MessageBox,NULL,  lpText,addr AppName,MB_OK
;	RET	
;TestHello EndP

FindAndReplace proc lpSzFind:LPSTR, lpSzReplace:LPSTR, lpSzText:LPSTR
	
	;Setup locals
	LOCAL lpSzBuffer:DWORD
	LOCAL szBuffer:BYTE
	LOCAL sourceLen:DWORD
	LOCAL lpText:DWORD
	LOCAL findLen:DWORD
	LOCAL replaceLen
	LOCAL findCount:DWORD
	
	;Derefrence lpSzText because it is passed by reference
	mov eax, lpSzText ; copy address into eax
	mov eax, [eax] ; dereference it
	mov lpText, eax
	
	;Count occurances of lpSzFind in lpSzText	
	mov findCount, rv(szWcnt, lpText, lpSzFind)

		
	;If we need to replace something
	.IF findCount > 0
	;execute these statements ...
		
		;Store buffer address		
		mov lpSzBuffer, ptr$(szBuffer)

		;Store source length
		mov sourceLen, len(lpText)

		;Add some padding to the source length
		add sourceLen, 16384

		;Store find length
		mov findLen, len(lpSzFind)
		
		;Store replace length
		mov replaceLen, len(lpSzReplace)
		
		mov eax, replaceLen						;Copy replaceLen for further operation
		
		.IF findLen >= eax
			;The source length is large enough
			
			nop
			
		.else
			;The buffer length needs to be extended
			
			sub eax, findLen					;Subtract findLen from replaceLen copy
			invoke IntMul, findCount, eax		;Multiply the difference
			add sourceLen, eax 					;Add the extra bytes to the source length
			 
		.endif
		
		xor eax, eax						;Clear eax because we have done nothing yet
		
		mov lpSzBuffer, alloc$(sourceLen)	;Allocate buffer space

		; perform replacement
		invoke szRep, lpText, lpSzBuffer, lpSzFind, lpSzReplace
		
		;Taking a shot in the dark here I am guessing my lpSzText buffer
		;Won't be large enough. So we will allocate the new source length
		
		mov lpText, alloc$(sourceLen)			;Using the fixed length allocation macro
		
		invoke szCopy, lpSzBuffer, lpText		;Return the new text			 

		free$ lpSzBuffer						;Deallocate buffer
		
	.endif	

	;Return 0 if nothing to do else return what we did.
	mov eax, findCount

	ret

FindAndReplace endp
 
End DllEntry
